//
//  MaulwurfAppDelegate.m
//  Maulwurf
//
//  Created by Holger Hinzberg
//  http://www.cocoa-coding.de/kids 

#import "MaulwurfAppDelegate.h"

@implementation MaulwurfAppDelegate

@synthesize window;
@synthesize textSpielzeit;
@synthesize textAnzeigezeit;
@synthesize sliderSpielzeit;
@synthesize sliderAnzeigezeit;
@synthesize maulwurfButton1;
@synthesize maulwurfButton2;
@synthesize maulwurfButton3;
@synthesize maulwurfButton4;
@synthesize maulwurfButton5;
@synthesize maulwurfButton6;
@synthesize maulwurfButton7;
@synthesize maulwurfButton8;
@synthesize maulwurfButton9;
@synthesize maulwurfButton10;
@synthesize maulwurfButton11;
@synthesize maulwurfButton12;
@synthesize fortschrittsbalken;

- (void) awakeFromNib
{
    highscore = 0;
    [self zeigeHighscoreInBadge];
}

- (void) zeigeHighscoreInBadge
{
    NSDockTile* meinDockTile;
    meinDockTile = [NSApp dockTile]; 
    
    NSString* badgeText
    = [NSString stringWithFormat:@"%i",
       highscore];
    
    meinDockTile = [NSApp dockTile]; 
    [meinDockTile setBadgeLabel:badgeText]; 
    [meinDockTile display];
}

- (IBAction)startButtonKLick:(id)sender;
{
    // Zähler zurücksetzten
    maulwurfZaehler = 0;
    sekundenZaehler = 0;
    
    NSInteger spielzeit = [sliderSpielzeit intValue];
    [fortschrittsbalken setMaxValue:spielzeit];
    NSInteger anzeigezeit = [sliderAnzeigezeit intValue];
        
    // Timer
    [timerLaufzeit invalidate];
    timerLaufzeit = 
    [NSTimer scheduledTimerWithTimeInterval:1
                                     target:self
                                   selector:@selector(ticktack:) 
                                   userInfo:nil 
                                    repeats:YES];
    
    [maulwurfZeit invalidate];
    maulwurfZeit = 
    [NSTimer scheduledTimerWithTimeInterval: anzeigezeit
                                     target:self
                                   selector:@selector(zeigeMaulwurf:) 
                                   userInfo:nil 
                                    repeats:YES];
   
    // Zufallszahlengenerator
    srandom((uint)time(NULL));
    [maulwurfZeit fire];
}

- (void)ticktack:(NSTimer *)aTimer
{
    NSInteger spielzeit = [sliderSpielzeit intValue];
    
    sekundenZaehler++;
    
    [fortschrittsbalken 
     setDoubleValue:sekundenZaehler];
    
    if(sekundenZaehler >= spielzeit )
    {
        [timerLaufzeit invalidate];
        [maulwurfZeit invalidate];
        
        NSString *meinText;
        if (maulwurfZaehler == 0)
        {
            meinText = [NSString stringWithFormat:
             @"Du hast keinen Maulwurf erwischt."];
        }
        else if (maulwurfZaehler == 1)
        {
            meinText = [NSString stringWithFormat:
            @"Du hast einen Maulwurf erwischt."];
        }
        else
        {
            meinText = [NSString stringWithFormat:
             @"Du hast %i Maulwürfe erwischt.",
             maulwurfZaehler];        
        }
        
        NSRunAlertPanel(@"Die Zeit ist abgelaufen.",
                        meinText,@"OK", nil, nil);
        
        
        if (maulwurfZaehler > highscore)
        {
            highscore = maulwurfZaehler;
           [self zeigeHighscoreInBadge];
        }
    }
}






- (void)zeigeMaulwurf:(NSTimer *)aTimer
{
    // Alle Buttons werden unsichtbar
    [maulwurfButton1 setHidden:YES];
    [maulwurfButton2 setHidden:YES];
    [maulwurfButton3 setHidden:YES];
    [maulwurfButton4 setHidden:YES];
    [maulwurfButton5 setHidden:YES];
    [maulwurfButton6 setHidden:YES];
    [maulwurfButton7 setHidden:YES];
    [maulwurfButton8 setHidden:YES];
    [maulwurfButton9 setHidden:YES];
    [maulwurfButton10 setHidden:YES];
    [maulwurfButton11 setHidden:YES];
    [maulwurfButton12 setHidden:YES];
    
    // Eine Zufallszahl von 1 bis 12
    int zufallszahl = (int) (random() % 12) + 1;
    
    // Einen Button wieder sichtbar machen
    switch (zufallszahl)
    {
        case 1:
            [maulwurfButton1 setHidden:NO];
            break;
        case 2:
            [maulwurfButton2 setHidden:NO];
            break;
        case 3:
            [maulwurfButton3 setHidden:NO];
            break;
        case 4:
            [maulwurfButton4 setHidden:NO];
            break;
        case 5:
            [maulwurfButton5 setHidden:NO];
            break;
        case 6:
            [maulwurfButton6 setHidden:NO];
            break;
        case 7:
            [maulwurfButton7 setHidden:NO];
            break;
        case 8:
            [maulwurfButton8 setHidden:NO];
            break;
        case 9:
            [maulwurfButton9 setHidden:NO];
            break;
        case 10:
            [maulwurfButton10 setHidden:NO];
            break;
        case 11:
            [maulwurfButton11 setHidden:NO];
            break;
        case 12:
            [maulwurfButton12 setHidden:NO];
            break;
    }
}


- (IBAction)maulwurfButtonKlick:(id)sender
{
    maulwurfZaehler++;
    [maulwurfZeit fire];
}

- (IBAction)verschiebeAnzeigezeit:(id)sender
{
    NSInteger wert = [sliderAnzeigezeit intValue];
    [textAnzeigezeit setIntegerValue:wert];
}

- (IBAction)verschiebeSpielzeit:(id)sender 
{
    NSInteger wert = [sliderSpielzeit intValue];
    [textSpielzeit setIntegerValue:wert];   
}

@end
